﻿namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    private static void Main()
    {
        Random random = new Random();

        List<Product> sourceList = new List<Product>();

        for(int i = 0; i < 100; i++)
        {
            int value = random.Next(1, 10);

            sourceList.Add(new Product { ProductCode = $"제품코드 {value}", Name = $"제품명 {value}", Price = random.Next(1000, 10000) });
        }

        List<ProductSummary> targetList = sourceList
            .GroupBy(source => source.ProductCode)
            .Select
            (
                sourceGroup => new ProductSummary
                {
                    ProductName = sourceGroup.First().Name,
                    Quantity    = sourceGroup.Count().ToString(),
                    Amount      = sourceGroup.Sum(c => c.Price).ToString(),
                }
            )
            .OrderBy(source => source.ProductName)
            .ToList();

        foreach(ProductSummary summary in targetList)
        {
            Console.WriteLine(summary);
        }
    }

    #endregion
}